# std::invalid_argument

From cppreference.com
< cpp‎ | error

Defined in header `<stdexcept>` |  |
class invalid_argument; |  |

Defines a type of object to be thrown as exception. It reports errors that arise because an argument value has not been accepted.

This exception is thrown by std::bitset::bitset, and the std::stoi and std::stof families of functions.

Inheritance diagram

### Member functions

(constructor) | constructs the exception object (public member function)

## std::invalid_argument::invalid_argument

explicit invalid_argument( const std::string& what_arg ); | (1) |
explicit invalid_argument( const char* what_arg ); | (2) | (since C++11)

Constructs the exception object with `what_arg` as explanatory string that can be accessed through what().

Because copying `std::invalid_argument` is not permitted to throw exceptions, this message is typically stored internally as a separately-allocated reference-counted string. This is also why there is no constructor taking `std::string&&`: it would have to copy the content anyway.

### Parameters

what_arg | - | explanatory string

### Exceptions

May throw std::bad_alloc

## Inherited from std::exception

### Member functions

(destructor) [virtual] | destroys the exception object (virtual public member function of `std::exception`)
what [virtual] | returns an explanatory string (virtual public member function of `std::exception`)

### Notes

The purpose of this exception type is similar to the error condition std::errc::invalid_argument (thrown in std::system_error from member functions of std::thread) and the related errno constant EINVAL.

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/error/invalid_argument&oldid=70827"